var req;
		
function addListeners ()
{
  // add keyup-handlers
	for(var x=0; x<9; ++x){
		for(var y=0; y<9; ++y){
			var box = eval("document.EntryGrid.grid"+x+y);
			box.addEventListener("keydown", keydown, true);
		}	
	}	
	
	var wrapper = document.getElementById("wrapper");
    wrapper.addEventListener("keydown", keydown, true);
    
    document.EntryGrid.addEventListener ("keydown", keydown, true);
    document.EntryGrid.addEventListener ("submit", submit, true);
}

function processReqChange()
{
	if(req.readyState != 4) return; // only if "OK"

	if (req.status == 200){
		var div = document.getElementById("wrapper");
		div.innerHTML = req.responseText;			
	} else {
		var div = document.getElementById("wrapper");
		div.innerHTML = "Error Loading " + req.statusText;
	}
	req = null;
	
	
	addListeners ();
	
    
    savePrefs();
}		

/*
 *  move
 */
function move(name, dx,dy) // move focus
{
	var x=parseInt(name[4]), y=parseInt(name[5]);
	var i=0;
	do{
		x+=dx; if(x<0) x+=9; if(x>8) x-=9;
		y+=dy; if(y<0) y+=9; if(y>8) y-=9;
		var box = eval("document.EntryGrid.grid"+x+y);
		++i;
	}while(box.type!="text" && i<10);
	event.stopPropagation();
	event.preventDefault();
	box.focus();
	box.select();
}

/*
 *  submit
 */
function submit (ev)
{

   debug ( "Form suppressed" );
   ev.stopPropagation();
   ev.preventDefault();

  return true;
}

/*
 *  keydown
 */
function keydown(ev)
{

   debug ( "Keydown " + window.event.keyCode );

   
    
	
    if ( ! ( ( window.event.keyCode >= 49 && window.event.keyCode <= 57 ) || 
             window.event.keyCode == 9 ||
             (window.event.keyCode >= 97 && window.event.keyCode <= 105 ) ) )
    {
    switch(window.event.keyCode){
		case 37: move(this.name, -1, 0); break; //left
		case 39: move(this.name,  1, 0); break; //right
		case 38: move(this.name,  0,-1); break; //up
		case 40: move(this.name,  0, 1); break; //down
		case  8: 
		case 46: 
		  this.value=""; 
		  break; //backspace, del
    
        default:
          debug ( "Keydown " + window.event.keyCode  +"blocked");
          ev.stopPropagation();
  	      ev.preventDefault();
	      return true;
	}
	
    
    }
    
    this.style.color = "#555";
    
}
	
function keyup(ev)
{
	switch(window.event.keyCode){
		case 37: move(this.name, -1, 0); break; //left
		case 39: move(this.name,  1, 0); break; //right
		case 38: move(this.name,  0,-1); break; //up
		case 40: move(this.name,  0, 1); break; //down
		case  8: case 46: this.value=""; /*fallthrough*/ //backspace, del
     //   default: check();
	}
	if (window.event.keyCode == 13)
    {
        ev.stopPropagation();
	    ev.preventDefault();
    }
}

/*
 *      load
 */
function load ()
{
	var url="http://www.sudokufun.com/dashboard.php";

	req = new XMLHttpRequest();
	req.onreadystatechange = processReqChange;
	req.open("GET", url, false);
	req.send(null);
	
	
}

var frontside = true;

function showbackside (event)
{
	var front = document.getElementById("widgetFront");
	var back = document.getElementById("widgetBack");
	
	event.stopPropagation();
	event.preventDefault();

	if (window.widget){
		widget.prepareForTransition(frontside ? "ToBack" : "ToFront");
		frontside = !frontside;
		front.style.display=(frontside ? "block" : "none");
		back.style.display=(frontside ? "none" : "block");
		window.setTimeout("widget.performTransition();", 0);
	}
	
}

function overInfo(id)
{
	document.getElementById(id).style.opacity = 0.50;
}

function offInfo(id)
{
	document.getElementById(id).style.opacity = 0.25;
}



function onshow() {
}
function onhide() {
  savePrefs();
}

/*
 *
 */
function init()
{
  if ( window.widget )
  {
    if ( widget.preferenceForKey ( "grid" ) != undefined )
    {
      loadPrefs();
    }
    else
	  load();
  }
  else load();


	
  if ( window.widget )
  {
    widget.onremove = onhide;
    widget.onhide = onhide;
  }

}

function viewSolution(event)
{
	if (window.widget)
	{
		var id = document.EntryGrid.id.value;
		var url ="http://www.sudokufun.com/solution.php?id="+id;
    	widget.openURL( url );
	}
}

function visit( url )
{
	if (window.widget) widget.openURL( url );
}


function getval(col, row)
{
	var val = eval("document.EntryGrid.grid"+col+row+".value");
	if(val == "")
	  return 0;
	val=parseInt(val);
	return (0<=val && val<=9 ? val : 0);
}

function isClue (col, row)
{
	var type = eval("document.EntryGrid.grid"+col+row+".type");
	if(type == "hidden")
	  return true;
	return false;
}

function flagBox(x,y,error)
{
	var box = eval("document.EntryGrid.grid"+x+y);
	box.style.color=(error ? "#E00" : "#000");
}

/*
 *  check
 */
function check()
{

	var ok = true, done = true;

	var check1 = new Array(10), check2 = new Array(10);
	var x,y,i;
	var flags = new Array(9*9), val = new Array(9*9);

	// reset error-flags and cache values
	for(y=0; y<9; ++y){
		for(x=0; x<9; ++x){
			flags[9*y+x]=false;
			val[9*y+x]=getval(x,y);
		}
	}

	// check rows and columns
	for(y=0; y<9; ++y){
		for(i=0; i<10; ++i) check1[i]=check2[i]=0;
		for(x=0; x<9; ++x){
			++check1[val[9*y+x]]; // row y
			++check2[val[9*x+y]]; // column y
		}
		for(i=1; i<10; ++i){
			if(check1[i]>1){
				ok=false;
				for(var j=0; j<9; ++j){
					if(val[9*y+j]==i) flags[9*y+j]=true;
				}
			}
			if(check2[i]>1){
				ok=false;
				for(var j=0; j<9; ++j){
					if(val[9*j+y]==i) flags[9*j+y]=true;
				}
			}
		}
		if(check1[0]>0) done=false;
	}

	// check 3x3 blocks
	for(var Y=0; Y<3; ++Y){
		for(var X=0; X<3; ++X){
			for(i=0; i<10; ++i) check1[i]=0;
			for(x=0; x<3; ++x){
				for(y=0; y<3; ++y){
					++check1[val[9*(3*Y+y)+3*X+x]];
				}
			}
			for(i=1; i<10; ++i) if(check1[i]>1){
				ok=false;
				for(x=0; x<3; ++x){
					for(y=0; y<3; ++y){
						if(val[9*(3*Y+y)+3*X+x]==i)
							flags[9*(3*Y+y)+3*X+x]=true;
					}
				}
			}
		}
	}

	// apply error-flags
	for(y=0; y<9; ++y){
		for(x=0; x<9; ++x){
			flagBox(x,y,flags[9*y+x]);
		}
	}

	if(!ok	) return 0;
	if(!done) return 1;
	return 2;
}

function checkGrid()
{
	var state=check(), popup;
	if(state==2){
		// congratulations
		popup = document.getElementById("congratulations");
	}else if(state==1){
		// keep trying..
		popup = document.getElementById("keeptrying");
  	}else{
  		// errors
		popup = document.getElementById("badluck");
  	}
	popup.style.display="block";
}

/*
 *  ok
 */
function ok ( id )
{
	var popup = document.getElementById( id );
	popup.style.display="none";
}



/*
 *  clearPrefs
 */
function clearPrefs ()
{
  widget.setPreferenceForKey(null, "grid");
  
  var x,y;
    for(y=0; y<9; ++y)
    {
  	  for(x=0; x<9; ++x)
  	  {
        var key =  "grid"+x+y;
        widget.setPreferenceForKey(null, key);
         
      }
	}

}

/*
 *  loadPrefs
 */
function loadPrefs ()
{
  debug ("load prefs");
  
  var grid = widget.preferenceForKey("grid");
  
  var div = document.getElementById("wrapper");
  
  div.innerHTML = grid;
  
  var x,y;
    for(y=0; y<9; ++y)
    {
  	  for(x=0; x<9; ++x)
  	  {
        var key =  "grid"+x+y;
        var val = widget.preferenceForKey( key );
        
        if ( val != undefined )
        {
          var item = eval("document.EntryGrid.grid"+y+x);
          item.value = val;
        }
         
      }
	}
	
  addListeners ();

}

/*
 *  savePrefs
 */
function savePrefs ()
{

  debug ("Save");
  clearPrefs();
  
  if(window.widget)
  {
  
    var x,y;
    for(y=0; y<9; ++y)
    {
  	  for(x=0; x<9; ++x)
  	  {
        if ( isClue (y,x) == false )
        {
          var val =  getval(y,x);
          
          if (val > 0) 
          {
            var key =  "grid"+x+y;
            widget.setPreferenceForKey(val, key);
          }  
        
        }
      }
	}
	
	var div = document.getElementById("wrapper");
    widget.setPreferenceForKey(div.innerHTML, "grid");
    
  }
}

/*
 *  debug
 */
function debug ( str )
{
  return;
  var debug = document.getElementById("debug");
  debug.innerHTML = str;
}
